
;Script File Locator

;Created By CyPliX

;How to use
;Open the script locator dialog in your drop menu: Script Scanner>Open Dialog
;Press the 'Scan' button.

;The list will only show those scripts that are located within areas that your current scripts are loaded and of course your mirc directory.
;The scanner will only locate those files with a suffix of .ini or .mrc
;You can choose to view the script, load it into your current mirc, delete the file.
;I've given you the option to evan view the file size, creation date and when it was last modified

;Version History
;v1.1
;Fixed loadbuf error line 122. Now checks if slscan.txt file exists
;Added selective directory scanning, gives user the option of scanning their own directories.
;Added intensive directory scanning, gives the option to scan sub-directories

;Warning! Use at your own risk, scanning drive letters such as c:\ can cause mirc to become unstable.

dialog script-locator {
  title "Script Locator v1.1 - Created By CyPlIX"
  size -1 -1 186 126
  option dbu
  list 1, 4 17 135 95, sort size hsbar vsbar
  link "Scripts:", 2, 3 6 22 8
  button "Scan", 3, 140 114 37 12
  text "scan.info", 7, 1 117 138 8
  button "Delete", 8, 145 18 30 10
  button "Load", 9, 145 30 30 10
  button "View", 4, 145 42 30 10
  button "Close", 5, 156 116 29 10, hide ok
  text "0", 6, 113 9 25 8, right
  text "file.info", 10, 141 55 43 56
  button "Dir", 11, 177 114 9 12
}

dialog script-locator_de {
  title "Script Locator v1.1 - Created By CyPlIX"
  size -1 -1 288 250
  option dbu
  edit "", 1, 0 1 288 235, group multi autohs autovs hsbar vsbar
  button "Close", 2, 258 239 27 10, ok
  button "Delete", 3, 227 239 27 10
  button "Move", 4, 195 239 27 10
  text "Text Label", 5, 3 240 149 8, nowrap
  text "line.info", 6, 154 240 37 8, right
}

menu menubar {
  -
  Script Scanner
  .$iif($dialog(script-locator),Show,Open) Dialog: dialog $iif($dialog(script-locator),-v,-m script-locator) script-locator
  .$iif($dialog(script-locator),Close Dialog): { 
    dialog -x script-locator
    dialog -x script-locator_de 
    if ($timer(sldl)) .timersldl off
  }
  .-
  .Scan: sl.scan
}
alias -l sl.scan {
  var %dirs,%sub = 0
  :start

  if ($1 isnum) var %sub = $1
  if ($numtok($2,63) > 0) var %dirss = $2-
  if (!$dialog(script-locator)) dialog -m script-locator script-locator

  did -r script-locator 1
  did -r script-locator 10
  did -o script-locator 6 1 $did(script-locator,6).lines

  if ($exists(slscan.txt)) .remove slscan.txt

  var %scripts,%aliases,%variables,%v,%n,%rslt
  var %n = 1 | while (%n <= $script(0)) { var %scripts = $addtok(%scripts,$script(%n),63),%dirs = $addtok(%dirs,$nofile($script(%n)),63) | inc %n }
  var %n = 1 | while (%n <= $alias(0)) { var %aliases = $addtok(%aliases,$alias(%n),63),%dirs = $addtok(%dirs,$nofile($alias(%n)),63) | inc %n }
  var %n = 1 | while (%n <= $popup(0)) { var %popups = $addtok(%popups,$popup(%n),63),%dirs = $addtok(%dirs,$nofile($popup(%n)),63) | inc %n }

  var %dirs = $addtok(%dirs,$mircdir,63)
  var %dirs = $addtok(%dirs,$nofile($users),63)
  var %dirs = $addtok(%dirs,$nofile($variables),63)
  var %dirs = $addtok(%dirs,%dirss,63)

  var %n.d = 1,%x = 0
  did -o script-locator 6 1 %x
  while (%n.d <= $numtok(%dirs,63)) {
    var %dir = $gettok(%dirs,%n.d,63)
    ;;
    ;mrc search
    var %n.fm = 1,%ffsm = $findfile(%dir,*.mrc,0,%sub)
    while (%n.fm <= %ffsm) {
      var %file = $findfile(%dir,*.mrc,%n.fm,%sub)
      if (!$script(%file)) && (%file) {
        if ($dialog(script-locator)) {
          var %rd = $read(slscan.txt,w,%file)

          ;;its probably not neccessary to check for duplicates but 
          ;;after having probs then realising i made a spelling mistake I decided to leave it in

          if (!%rd) write slscan.txt %file
          inc %x
          did -o script-locator 6 1 $lines(slscan.txt)
        }
      }

      if ($dialog(script-locator)) did -o script-locator 7 1 Scanning: %file

      inc %n.fm
    }

    ;ini search
    var %n.fi = 1,%ffsi = $findfile(%dir,*.ini,0,%sub)
    while (%n.fi <= %ffsi) {
      var %file = $findfile(%dir,*.ini,%n.fi,%sub)
      if ($dialog(script-locator)) && (%file) {
        var %rd = $read(slscan.txt,w,%file)
        if (!%rd) && (($ini(%file,script,0) != 0) || ($ini(%file,aliases,0) != 0) || ($ini(%file,users,0) != 0) || ($ini(%file,variables,0) != 0) || ($ini(%file,mpopup,0) != 0) || ($ini(%file,qpopup,0) != 0) || ($ini(%file,lpopup,0) != 0) || ($ini(%file,bpopup,0) != 0) || ($ini(%file,cpopup,0) != 0)) write slscan.txt %file
        inc %x
        did -o script-locator 6 1 $lines(slscan.txt)
      }
      inc %n.fi
    }
    ;;
    inc %n.d
  }
  if ($exists(slscan.txt)) {
    .loadbuf -o script-locator 1 slscan.txt
    did -v script-locator 1
    did -c script-locator 1 1
    did -o script-locator 10 1 Size: $bytes($file($did(script-locator,1).seltext).size,k).suf $crlf $crlf $+ Created: $crlf $+ $asctime($file($did(script-locator,1).seltext).ctime,dd mmm yyyy)  $crlf $crlf $+ Last Modified: $crlf $+ $asctime($file($did(script-locator,1).seltext).mtime,dd mmm yyyy)
    if ($dialog(script-locator)) did -o script-locator 7 1 Scanning Complete.
    if ($exists(slscan.txt)) .remove slscan.txt
    if ($did(script-locator,1).lines > 0) did -e script-locator 4,8,9
  }
  else { 
    if ($dialog(script-locator)) did -o script-locator 7 1 No unloaded scripts found 
    var %dir
    if ($input(Would you like to preform a selective scan?,y,Selective Scan) == $true) {
      :another
      var %d = $sdir($mircdir,Select a directory you wish to include in the scan)
      if (%d != $null) {
        var %dirss = $addtok(%dirss,%d,63)
        if ($input(Would you like to include another?,y) == $true) goto another
        else {
          var %sub = $iif($input(Would you like to include sub-directories in your scan?,ey,Increase Intensity,5000),$iif($ifmatch isnum,$ifmatch,0))
          goto start
        }
      }
    }
  }
}
alias -l popup { if (!$1) return $ini(mirc.ini,pfiles,0) | else return $readini(mirc.ini,pfiles,$ini(mirc.ini,pfiles,$1)) }
alias -l users return $readini(mirc.ini,rfiles,n0)
alias -l variables return $readini(mirc.ini,rfiles,n1)

on *:dialog:script-locator:init:0: {
  did -o $dname 7 1 Press the 'Scan' button to begin! --->
  did -r $dname 10
  did -b $dname 4,8,9
}
on *:dialog:script-locator:close:0: {
  if ($dialog(script-locator_de)) {
    .dialog -x script-locator_de
    .timersldl off
  }
}

on *:dialog:script-locator:sclick:*: {
  if ($did == 1) did -o script-locator 10 1 Size: $bytes($file($did(1).seltext).size,k).suf $crlf $crlf $+ Created: $crlf $+ $asctime($file($did(1).seltext).ctime,dd mmm yyyy)  $crlf $crlf $+ Last Modified: $crlf $+ $asctime($file($did(1).seltext).mtime,dd mmm yyyy)
  elseif ($did == 3) sl.scan
  elseif ($did == 4) {
    if (!$dialog(script-locator_de)) .dialog -m script-locator_de script-locator_de
    .dialog -v script-locator_de
    did -r script-locator_de 1
    .loadbuf -ofz script-locator_de 1 $+(",$did(1).seltext,")
    did -c script-locator_de 1 1
    did -o script-locator_de 5 1 $did(1).seltext
  }
  elseif ($did == 8) {
    if ($did(1).seltext) {
      .remove -b $did(1).seltext
      did -d $dname 1 $did(1).sel
      did -o $dname 6 1 $calc($did($dname,6) - 1)
    }
  }
  elseif ($did == 9) /load -rs $did(1).seltext
  elseif ($did == 11) {
    :another
    var %d = $sdir($mircdir,Select a directory you wish to include in the scan)
    if (%d != $null) {
      var %dirss = $addtok(%dirss,%d,63)
      if ($input(Would you like to include another?,y) == $true) goto another
      else {
        var %sub = $iif($input(Would you like to include sub-directories in your scan?,ey,Increase Intensity,5000),$iif($ifmatch isnum,$ifmatch,0))
        sl.scan %sub %dirss
      }
    }
  }
}
on *:dialog:script-locator_de:init:0: .timersldl -m 0 100 did -o $dname 6 1 $!did(script-locator_de,1,1).sel $!+ $!chr(47) $!+ $!did(script-locator_de,1).lines
on *:dialog:script-locator_de:close:0: .timersldl off
on *:dialog:script-locator_de:sclick:*: {
  if ($did == 3) {
    if ($exists($did(5))) .remove -b $did(5)
    did -d script-locator 1 $didwm(script-locator,1,$did(5))
    did -o script-locator 6 1 $calc($did(script-locator,6) - 1)
    .timersldl off
    .dialog -x $dname
  }
  elseif ($did == 4) {
    var %w = $sdir($did(5),Select where you would like this file to be moved to)
    if (%w) {
      .rename $+(,$did(5),) $+(,%w $+ $nopath($did(5)),)
      did -o script-locator 1 $didwm(script-locator,1,$did(5)) %w $+ $nopath($did(5))
      did -o $dname 5 1 %w $+ $nopath($did(5))
      did -c script-locator 1 $didwm(script-locator,1,$did(5))
    }
  }
}
on *:unload: {
  if ($dialog(script-locator)) .dialog -x script-locator
  if ($dialog(script-locator_de)) .dialog -x script-locator_de
}
